#include "header\GBA.h"
#include "header\BG.h"
#include "header\Timer.h"
#include "header\DMA.h"
#include "header\IRQ.h"
#include "header\sound.h"
#include "header\sprite.h"

#include "lib.h"
#include "iwram.h"

__attribute__ ((section (".iwram0")))
u32 iwramMem[IWRAM_MEM_SIZE];

u32 (*iwramFunc1)(void);

void iwramInitialize(){
  u32 i;
  u32 iwramFunction1Size = (u32)&iwramDummy1 - (u32)&iwramFunction1;

  if(IWRAM_MEM_SIZE < iwramFunction1Size){
    dprintf("IWARMInitialize Error\n");
    while(1){}
  }

  // 荞݊֐IWRAMɃRs[
  for(i=0; i<iwramFunction1Size/4; i++){
    iwramMem[i]=((u32*)iwramFunction1)[i];
  }
  iwramFunc1 = (u32(*)(void))&iwramMem[0];
  dprintf("ROM   Func1  Ptr=0x%x\n", iwramFunction1);
  dprintf("IWARM Func1  Ptr=0x%x\n", iwramFunc1);
  dprintf("IWARM Func1 Size=0x%x\n", iwramFunction1Size);
}

u32 iwramFunction1(void)
{
  u32 cnt;
  u32 a,b,c,d,e,f,g,h;
  a=1;
  b=1;
  e=3;
  for(cnt=1024;cnt!=0;cnt--){
    c=a+b;
    d=(c<<4)+a;
    if(d==0) a=2;
    f=c*a+b;
    g=a-b-c-d-e;
    h=g-c*a*b*c;
  }
  return(a-b-c-d-e-f-g-h);
}

void iwramDummy1(){
}
