#include "header\GBA.h"
#include "header\BG.h"
#include "header\Timer.h"
#include "header\DMA.h"
#include "header\IRQ.h"
#include "header\sound.h"
#include "header\sprite.h"

#include "lib.h"
#include "iwram.h"
#include "irq.h"
#include "syscall.h"

#include "data.h"
#include "resource\BitMapFont.h"

#include <stdlib.h> 

//const int __gba_multiboot;  //GBANp
//---------------------------------------------------------------------------
typedef struct {
	u16 cx;
	u16 cy;
	u16 BmpCx;
	u16 BmpCy;
	u16 NextMark;
	u16 NextPaint;
} ST_CARD;

ST_CARD CARD;

#define CARD_DECK_CNT (13*4)	//13*4}[N
u8 CardDeck[CARD_DECK_CNT];		//fbL
u8 DeckCnt;						//fbL牽ôp

u8 CardHand[5];					//D
u8 CardHold[5];					//Dz[hptO
u16 Coin;
u16 Bet;
//---------------------------------------------------------------------------
void Init();
void InputBet();
void Shuffle();
void SelectHold();
void JudgeCard();
void ChangeCard();
void SortCard();

void DispHand();
void DispCard(u8 x, u8 y, u8 num);
void DispHold(int);
void DispSelect(int, int);
//---------------------------------------------------------------------------
void JudgeCard(){
	u8 Pair=0;
	u8 PairTwo=0;
	u8 PairThree=0;
	u8 PairFour=0;
	u8 Flash=0;
	u8 Straight=0;

	u8 PairFlag[13];
	u8 MarkFlag[4];
	u8 st;
	int i;

	//
	for(i=0; i<13; i++)
		PairFlag[i]=0;
	for(i=0; i<4; i++)
		MarkFlag[i]=0;

	//yAAtbV̔
	for(i=0; i<5; i++){
		PairFlag[ CardHand[i]%13 ]++;
		MarkFlag[ CardHand[i]/13 ]++;

		if(PairFlag[ CardHand[i]%13 ] == 2) Pair++;
		if(Pair == 2                      ) PairTwo=1;
		if(PairFlag[ CardHand[i]%13 ] == 3) PairThree=1;
		if(PairFlag[ CardHand[i]%13 ] == 4) PairFour=1;

		if(MarkFlag[ CardHand[i]/13 ] == 5) Flash=1;
	}

	//Xg[g̔
	st=0;
	for(i=0; i<5-1; i++){
		if( (CardHand[i]%13)+1 == (CardHand[i+1]%13) )
			st++;
	}
	if(st == 4) Straight=1;

	//--------------------------------------------
	//

	//CXg[gtbV
	if(st == 3 && Flash){
		if(CardHand[0]%13 == 0 && CardHand[4]%13 == 12){
			Coin += Bet*500;
			Mode3DrawBitMapStr(1,4,"Royal Flush");
			return;
		}
	}
	//Xg[gtbV
	if(Straight && Flash){
		Coin += Bet*100;
		Mode3DrawBitMapStr(1,4,"Straight Flush");
		return;
	}
	//tH[J[h
	if(PairFour){
		Coin += Bet*50;
		Mode3DrawBitMapStr(1,4,"Four of a Kind");
		return;
	}
	//tnEX
	if(PairTwo && PairThree){
		Coin += Bet*30;
		Mode3DrawBitMapStr(1,4,"Full House");
		return;
	}
	//tbV
	if(Flash){
		Coin += Bet*20;
		Mode3DrawBitMapStr(1,4,"Flush");
		return;
	}
	//Xg[g
	if(Straight){
		Coin += Bet*10;
		Mode3DrawBitMapStr(1,4,"Straight");
		return;
	}
	//X[J[h
	if(PairThree){
		Coin += Bet*5;
		Mode3DrawBitMapStr(1,4,"Three of a kind");
		return;
	}
	//c[yA
	if(PairTwo){
		Coin += Bet*2;
		Mode3DrawBitMapStr(1,4,"Two pairs");
		return;
	}
	//͂
	Mode3DrawBitMapStr(1,4,"ouch!");
}
//---------------------------------------------------------------------------
void DispSelect(int P, int j){
	if(j){
		Mode3DrawBitMapStr(P*6+0,14,"[");
		Mode3DrawBitMapStr(P*6+5,14,"]");
	}else{
		Mode3DrawBitMapStr(P*6+0,14," ");
		Mode3DrawBitMapStr(P*6+5,14," ");
	}
}
//---------------------------------------------------------------------------
void DispHold(int P){
	if( !CardHold[P] ){
		Mode3DrawBitMapStr(P*6+1,14,"HOLD");
		CardHold[P]=1;
	}else{
		Mode3DrawBitMapStr(P*6+1,14,"    ");
		CardHold[P]=0;
	}
}
//---------------------------------------------------------------------------
void ChangeCard(){
	int i;
	for(i=0; i<5; i++){
		if( !CardHold[i] ){
			CardHand[i] = CardDeck[DeckCnt++];
		}
	}
//CardHand[0] = 0  +13*3;
//CardHand[1] = 9  +13*3;
//CardHand[2] = 10 +13*3;
//CardHand[3] = 11 +13*3;
//CardHand[4] = 12 +13*3;
	DispHand();
}
//---------------------------------------------------------------------------
void SelectHold(){
	s8 HoldP=0;
	int i;
	for(i=0; i<5; i++){		//@ʁAHoldZNg
		CardHold[i]=1;

		WaitForVsync();
		DispHold(i);
		DispSelect(i,0);
	}

	while( *KEYS & KEY_A ){

		if( !(*KEYS & KEY_LEFT) ){
			DispSelect(HoldP,0);
			if(HoldP-1 >= 0) HoldP = (HoldP-1) % 5;
			else		   HoldP = 4;
		}
		if( !(*KEYS & KEY_RIGHT) ){
			DispSelect(HoldP,0);
			HoldP = (HoldP+1) % 5;
		}
		if( !(*KEYS & KEY_B) ){
			DispHold(HoldP);
		}

		while(!(*KEYS & KEY_B)){}
		while(!(*KEYS & KEY_LEFT)){}
		while(!(*KEYS & KEY_RIGHT)){}

		WaitForVsync();
		DispSelect(HoldP,1);
	}
}
//---------------------------------------------------------------------------
int main(void)
{
	Mode3SetBitMapFont((u8*)BitMapFont, 8,8,0);
	Mode3DrawBitMapStr(1,17,"Poker Sample. --");
	Mode3DrawBitMapStr(1,18,"2005/04/23 by Akkera.    ---");
	SetMode(MODE_3 | BG2_ENABLE);

	Init();

	for(;;){
		InputBet();
		Shuffle();
		DispHand();
		SelectHold();
		ChangeCard();
		JudgeCard();
		//GameOver

		while( *KEYS & KEY_A ){};
		Mode3DrawBox(0,0, 240,130, RGB(0,0,0));	//ʏ
	}
	return 0;
}
//---------------------------------------------------------------------------
void Shuffle(){
	u8 ct,cr1,cr2;
	int i;
	int endcnt = CARD_DECK_CNT*2;

	//Vbt
	for(i=0; i<endcnt; i++){
		cr1 = i      % CARD_DECK_CNT;
		cr2 = rand() % CARD_DECK_CNT;
		if(cr1 == cr2)
			continue;

		ct = CardDeck[cr1];
		CardDeck[cr1] = CardDeck[cr2];
		CardDeck[cr2] = ct;
	}

	//fbLDɓn
	DeckCnt=0;
	for(i=0; i<5; i++){
		CardHand[i] = CardDeck[DeckCnt++];
	}
}
//---------------------------------------------------------------------------
void InputBet(){
	char buf[32];
	Bet=1;

	REG_TM0CNT = 0x00C0; //_p

	bprintf(buf, "COIN:%3d", Coin);
	Mode3DrawBitMapStr(1,1,buf);

	while( *KEYS & KEY_A ){

		if( !(*KEYS & KEY_LEFT) ){
			if(Bet-1 >= 1)
				Bet--;
		}
		if( !(*KEYS & KEY_RIGHT) ){
			if(Bet+1 <= Coin)
				Bet++;
		}

		WaitForVsync();
		bprintf(buf, " BET:%3d", Bet);
		Mode3DrawBitMapStr(1,1+1,buf);
	}
	Coin -= Bet;

	REG_TM0CNT = 0x0000; // ^C}[~߂
	srand(REG_TM0D);
}
//---------------------------------------------------------------------------
void Init(){
	Coin = 20;

	CARD.cx = 48;
	CARD.cy = 64;
	CARD.BmpCx = 672;
	CARD.BmpCy = 672;
	CARD.NextMark  = CARD.BmpCx * CARD.cy;
	CARD.NextPaint = CARD.BmpCx - CARD.cx;

	int i;
	for(i=0; i<CARD_DECK_CNT; i++){
		CardDeck[i] = i;
	}
}
//---------------------------------------------------------------------------
//J[h\
void DispCard(u8 x, u8 y, u8 num){
	u16 *card   = (u16*)EtfsGetDataOffset(_CARD_IMG_BIN_OFFSET);
	u16 *Screen = VideoBuffer;
	u8 i,j;

	card   += (num/13)*CARD.NextMark;
	card   += (num%13)*CARD.cx;
	Screen += y*240+x;

	for(i=0; i<CARD.cy; i++){
		for(j=0; j<CARD.cx; j++){
			Screen[i*240+j] += *card++;
		}
		card += CARD.NextPaint;
	}
}
//---------------------------------------------------------------------------
void DispHand(){
	int i;

	//ёւ
	SortCard();
	//\
	for(i=0; i<5; i++){
		WaitForVsync();
		Mode3DrawBox(CARD.cx*i, 48, CARD.cx, CARD.cy, RGB(0,0,0));
		DispCard(CARD.cx*i, 48, CardHand[i]);
	}
}
//---------------------------------------------------------------------------
//J[h̕ёւ
void SortCard(){
	int i,j;
	u8 tmp;

	for(i=5-1; i>=1; i--){
		for(j=0; j<=i-1; j++){

			if(CardHand[j] > CardHand[j+1]){
				tmp = CardHand[j];
				CardHand[j] = CardHand[j+1];
				CardHand[j+1] = tmp;
			}

		}
	}
}
